#include <string>
#include <vector>

#define SQR(a) ((a)*(a))
#define uint unsigned int
#define ulong unsigned long

using namespace std;

//! convert to string
string strg( const string& val );
string strg( bool val );
string strg( int val );
string strg( uint val );
string strg( ulong val );
string strg( char val );
string strg( double val );

//! yaml
string yaml( const string );

namespace mystd {

    //! convert from string
    bool str2vec( string inp, vector<double> *V, uint nmax=0, bool force=true );
    bool any2dbl( const string& inp, double *val );
    bool any2int( const string& inp, int *val );
    bool any2uint( const string& inp, uint *val );

    //! string operations
    void string_extract_word( const string& in, string *out1, string *out2 );
    void string_extract_line( const string& in, string *out1, string *out2 );
    void string2words( const string& in, vector<string>& out );
    string strip( const string& str, const char* sepSet=" \n" );
    
    //! improved libc calls
    void system( string cmd );

    //! time
    double justnow();
    string myasctime( double time, int offs );

    //! rounding
    double round_decimal( double val, double digits );

    //! vector operations
    void merge( vector<double> *V, double val );
    // bool get_const( vector<double> *V, double* val=0 );
    void unique( vector<double> *V, 
                 double tolabs=1e-100, double tolrel=1e-10 );
    int sorted( const vector<double>& V );
    bool is_equidist( double *step, const vector<double>& V );
    double sum( const vector<double>& V );

    // file names, globbing, file read
    bool file_exists( const string& fname );
    void fname_divide( const string& fname, string *fdir,
                       string *fshort, string *fext);
    void glob_file_list( const string& pattern, const string& extension, 
                        vector<string> *fnames );
    string wordexp_unique( const string& s );
    int freadln( FILE *fd, string *s );
    string next_tmp_file( const string& path_format );

    // integration
    double Integrate( double (*func_) (double, void*), void *data_, 
                      double low, double hig,
                      uint mode, double epsabs, double epsrel );
}
